-- don't have to change shit when copying over changes from InF to standalone advanced movement/tactical weapon turnflip
AdvMov = AdvMov or {}
AdvMov.settings = AdvMov.settings or {}
AdvMov.settings.goldeneye = AdvMov.goldeneye or 1
AdvMov.settings.slidestealth = AdvMov.slidewpnangle or 2
AdvMov.settings.slideloud = AdvMov.slidewpnangle or 3
AdvMov.settings.slidewpnangle = AdvMov.slidewpnangle or 15
AdvMov.settings.wallrunwpnangle = AdvMov.slidewpnangle or 15
rel_cancel = nil
function PlayerStandard:_stance_entered(unequipped, timemult)
	local stance_standard = tweak_data.player.stances.default[managers.player:current_state()] or tweak_data.player.stances.default.standard
	local head_stance = self._state_data.ducking and tweak_data.player.stances.default.crouched.head or stance_standard.head
	local stance_id = nil
	local stance_mod = {
		translation = Vector3(0, 0, 0),
		rotation = Rotation(0, 0, 0)
	}

	local head_duration = tweak_data.player.TRANSITION_DURATION or 0.23
	local head_duration_multiplier = 1
	local duration = head_duration + (self._equipped_unit:base():transition_duration() or 0)
	--local duration = tweak_data.player.TRANSITION_DURATION + (self._equipped_unit:base():transition_duration() or 0)
	local duration_multiplier = self._state_data.in_steelsight and 1 / self._equipped_unit:base():enter_steelsight_speed_multiplier() or 1

	if not unequipped then
		stance_id = self._equipped_unit:base():get_stance_id()

		if self._state_data.in_steelsight and self._equipped_unit:base().stance_mod then
			stance_mod = self._equipped_unit:base():stance_mod() or stance_mod
		end
	end

	-- geddan
--[[
	stance_mod.rotation = stance_mod.rotation * Rotation(math.random(-90, 90), math.random(-90, 90), math.random(-90, 90))
	duration = 0.01
--]]


	-- shift melee weapons
	local tdmelee = tweak_data.blackmarket.melee_weapons[managers.blackmarket:equipped_melee_weapon()]
	if self._state_data.meleeing and tdmelee.stance_mod then
		if tdmelee.stance_mod.translation then
			stance_mod.translation = stance_mod.translation + tdmelee.stance_mod.translation
		end
		if tdmelee.stance_mod.rotation then
			stance_mod.rotation = stance_mod.rotation * tdmelee.stance_mod.rotation
		end
	end


	-- mid-reload viewmodel adjustments aka flipturn
	local reload_timed_stances = self._equipped_unit:base()._reload_timed_stance_mod
	if self:_is_reloading() and reload_timed_stances and self._flipturn_reload_state then
		local empty = 0
		local values = reload_timed_stances.not_empty
		if self._flipturn_reload_state > 99 then
			empty = 100
			values = reload_timed_stances.empty
		end
		if values then
			if self:in_steelsight() then
				values = values.ads
			else
				values = values.hip
			end
		end
		local flipturn_index = self._flipturn_reload_state - empty
		if values and values[flipturn_index] then
			if values[flipturn_index].translation then
				stance_mod.translation = stance_mod.translation + values[flipturn_index].translation
			end
			if values[flipturn_index].rotation then
				stance_mod.rotation = stance_mod.rotation * values[flipturn_index].rotation
			end
			if values[flipturn_index].sound and (flipturn_index > self._last_flipturn_sound) then
				self._unit:sound():_play(values[flipturn_index].sound)
				self._last_flipturn_sound = flipturn_index
			end
			duration_multiplier = duration_multiplier / (values[flipturn_index].speed or 1)
			duration_multiplier = duration_multiplier / (self._equipped_unit:base():reload_speed_multiplier()/self._equipped_unit:base():standard_reload_speed_multiplier())
		end
	end

	-- shell-by-shell viewmodel adjustments
	local shotgun_ammo_stances = self._equipped_unit:base()._shotgun_ammo_stance_mod
	if self:_is_reloading() and shotgun_ammo_stances then
		local values = shotgun_ammo_stances
		if values then
			if self:in_steelsight() then
				values = values.ads
			else
				values = values.hip
			end
		end
		local ammovalue = self._equipped_unit:base():get_ammo_remaining_in_clip() + 1
		if values and values[ammovalue] then
			if values[ammovalue].translation then
				stance_mod.translation = stance_mod.translation + values[ammovalue].translation
			end
			if values[ammovalue].rotation then
				stance_mod.rotation = stance_mod.rotation * values[ammovalue].rotation
			end
			if values[ammovalue].sound and (ammovalue > self._last_flipturn_sound) then
				self._unit:sound():_play(values[ammovalue].sound)
				self._last_flipturn_sound = ammovalue
			end
			duration_multiplier = duration_multiplier / (values[ammovalue].speed or 1)
			duration_multiplier = duration_multiplier / (self._equipped_unit:base():reload_speed_multiplier()/self._equipped_unit:base():standard_reload_speed_multiplier())
		end
	end

	-- post-shooting viewmodel adjustments aka shootturn
	-- works differently than the reload ones because i don't feel like going back and unfucking how the reload shit works
	local fire_timed_stances = self._equipped_unit:base()._fire_timed_stance_mod
	if fire_timed_stances and not self:_is_reloading() then
		if self:in_steelsight() then
			fire_timed_stances = fire_timed_stances.ads
		else
			fire_timed_stances = fire_timed_stances.hip
		end

		if fire_timed_stances[self._shootturn_state] then
			if fire_timed_stances[self._shootturn_state].translation then
				stance_mod.translation = stance_mod.translation + fire_timed_stances[self._shootturn_state].translation
			end
			if fire_timed_stances[self._shootturn_state].rotation then
				stance_mod.rotation = stance_mod.rotation * fire_timed_stances[self._shootturn_state].rotation
			end
			if fire_timed_stances[self._shootturn_state].sound and (self._shootturn_state > self._last_shootturn_sound) then
				if fire_timed_stances[self._shootturn_state].round_sound then
					if fire_timed_stances[self._shootturn_state].round_sound[self._equipped_unit:base():get_ammo_remaining_in_clip()] and fire_timed_stances[self._shootturn_state].round_sound[self._equipped_unit:base():get_ammo_remaining_in_clip()] == self._equipped_unit:base():get_ammo_remaining_in_clip() then
						self._unit:sound():_play(fire_timed_stances[self._shootturn_state].sound)
						self._last_shootturn_sound = self._shootturn_state
					end
				else
					self._unit:sound():_play(fire_timed_stances[self._shootturn_state].sound)
					self._last_shootturn_sound = self._shootturn_state
				end
			end
			duration_multiplier = duration_multiplier / (fire_timed_stances[self._shootturn_state].speed or 1)
			if self._shootturn_state == #fire_timed_stances then
				self._shootturn_state = nil
				self._last_shootturn_sound = 0
			end
		end
		duration_multiplier = duration_multiplier / (self._equipped_unit:base():fire_rate_multiplier())
	end
	
	if rel_cancel then
		if not unequipped then
			stance_id = self._equipped_unit:base():get_stance_id()

			if self._state_data.in_steelsight and self._equipped_unit:base().stance_mod then
				stance_mod = self._equipped_unit:base():stance_mod() or stance_mod
			end
		end
		rel_cancel = nil
	end
	
	-- static adjustment of stance when reloading
	if self._equipped_unit:base()._reload_stance_mod and self:_is_reloading() then
		if self._state_data.in_steelsight and self._equipped_unit:base()._reload_stance_mod.ads then
			if self._equipped_unit:base()._reload_stance_mod.ads.translation then
				stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._reload_stance_mod.ads.translation
			end
			if self._equipped_unit:base()._reload_stance_mod.ads.rotation then
				stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._reload_stance_mod.ads.rotation
			end
		elseif self._equipped_unit:base()._reload_stance_mod.hip then
			if self._equipped_unit:base()._reload_stance_mod.hip.translation then
				stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._reload_stance_mod.hip.translation
			end
			if self._equipped_unit:base()._reload_stance_mod.hip.rotation then
				stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._reload_stance_mod.hip.rotation
			end
		end
	end
	-- or while equipping
	if self._equipped_unit:base()._equip_stance_mod and self:is_equipping() then
		if self._equipped_unit:base()._equip_stance_mod.ads and self._state_data.in_steelsight then
			if self._equipped_unit:base()._equip_stance_mod.ads.translation then
				stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._equip_stance_mod.ads.translation
			end
			if self._equipped_unit:base()._equip_stance_mod.ads.rotation then
				stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._equip_stance_mod.ads.rotation
			end
		elseif self._equipped_unit:base()._equip_stance_mod.hip then
			if self._equipped_unit:base()._equip_stance_mod.hip.translation then
				stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._equip_stance_mod.hip.translation
			end
			if self._equipped_unit:base()._equip_stance_mod.hip.rotation then
				stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._equip_stance_mod.hip.rotation
			end
		end
	end
	-- or while sliding (and not ADS)
	if self._is_sliding and not self._state_data.in_steelsight then
		stance_mod.translation = stance_mod.translation + Vector3(0, -3, 0)
		stance_mod.rotation = stance_mod.rotation * Rotation(0, 0, AdvMov.settings.slidewpnangle)
	end
	if self._is_wallrunning and not self._state_data.in_steelsight then
		stance_mod.translation = stance_mod.translation + Vector3(0, -3, 0)
		stance_mod.rotation = stance_mod.rotation * Rotation(0, 0, -1 * AdvMov.settings.wallrunwpnangle)
	end
	if timemult then
		duration_multiplier = duration_multiplier * timemult
	end

	-- goldeneye
	if ((AdvMov.settings.goldeneye == 2 and self._equipped_unit:base().akimbo) or AdvMov.settings.goldeneye == 3 or self._equipped_unit:base()._use_goldeneye_reload) and self:_is_reloading() then
		stance_mod.translation = Vector3(0, 0, -100)
		stance_mod.rotation = Rotation(0, 0, 0)
	end
	
	local stances = nil
	stances = (self:_is_meleeing() or self:_is_throwing_projectile()) and tweak_data.player.stances.default or tweak_data.player.stances[stance_id] or tweak_data.player.stances.default
	local misc_attribs = stances.standard
	--misc_attribs = (not self:_is_using_bipod() or self:_is_throwing_projectile() or stances.bipod) and (self._state_data.in_steelsight and stances.steelsight or self._state_data.ducking and stances.crouched or stances.standard)
	misc_attribs = self:_is_using_bipod() and not self:_is_throwing_projectile() and stances.bipod or self._state_data.in_steelsight and stances.steelsight or self._state_data.ducking and stances.crouched or stances.standard
	local new_fov = self:get_zoom_fov(misc_attribs) + 0

	self._camera_unit:base():clbk_stance_entered(misc_attribs.shoulders, head_stance, misc_attribs.vel_overshot, new_fov, misc_attribs.shakers, stance_mod, duration_multiplier, duration, head_duration_multiplier, head_duration)
	--self._camera_unit:base():clbk_stance_entered(misc_attribs.shoulders, head_stance, misc_attribs.vel_overshot, new_fov, misc_attribs.shakers, stance_mod, duration_multiplier, duration)
	managers.menu:set_mouse_sensitivity(self:in_steelsight())
end

DelayedCalls:Add("turnflipworkwithCWAFplox", 0.5, function(self, params)
Hooks:PreHook(PlayerStandard, "_start_action_reload", "turnflip_sareload", function(self, t)
	local weapon = self._equipped_unit:base()
	if weapon and weapon:can_reload() then
		local tweak_data = weapon:weapon_tweak_data()
		if (weapon:clip_empty() and not (tweak_data.animations.ignore_fullreload or tweak_data.animations.ignore_nonemptyreload)) or tweak_data.animations.only_fullreload then
			self._flipturn_reload_state = 100
		else
			self._flipturn_reload_state = 0
		end
	end
	self:_stance_entered()
end)
end)

function PlayerStandard:_get_reload_expire()
	return self._state_data.reload_expire_t
end

Hooks:PreHook(PlayerStandard, "_update_reload_timers", "turnflip_updatereloadt", function(self, t, dt, input)
	-- mid-reload viewmodel adjustments
	local td = self._equipped_unit:base():weapon_tweak_data()
	if self:_is_reloading() and self._flipturn_reload_state and self._equipped_unit:base()._reload_timed_stance_mod then
		local empty = 0
		local values = self._equipped_unit:base()._reload_timed_stance_mod.not_empty or {}
		if self._flipturn_reload_state >= 100 then
			empty = 100
			values = self._equipped_unit:base()._reload_timed_stance_mod.empty or {}
		end
		if self:in_steelsight() then
			values = values.ads
		else
			values = values.hip
		end
		if values then
			for a, b in pairs(values) do
				--if (self._state_data.reload_expire_t - t) < values[a].t and a > (self._flipturn_reload_state - empty) then
				if (self:_get_reload_expire() and ((self:_get_reload_expire() - t) < values[a].t)) and a > (self._flipturn_reload_state - empty) then
					self._flipturn_reload_state = a + empty
					self:_stance_entered()
				end
			end
		end
	end
	if not self:_is_reloading() then
		self._flipturn_reload_state = nil
		self._last_flipturn_sound = 0
	end

	-- update stance when exiting shotgun reload
	if self._state_data.reload_expire_t and self._state_data.reload_expire_t <= t then
		if self._equipped_unit:base():reload_exit_expire_t() then
			self._queued_postreload_stance = true
		end
	end

	-- update stance every shell
	if self:_is_reloading() and self._equipped_unit:base()._use_shotgun_reload and self._equipped_unit:base()._next_shell_reloded_t and self._equipped_unit:base()._next_shell_reloded_t < t then
		self:_stance_entered()
	end
end)

Hooks:PostHook(PlayerStandard, "_update_reload_timers", "turnflip_updatereloadt2", function(self, t, dt, input)
	if self._queued_postreload_stance and not self:_is_reloading() then
		self._queued_postreload_stance = nil
		self:_stance_entered()
	end
end)

--[[
Hooks:PostHook(PlayerStandard, "_start_action_reload_enter", "turnflip_fuck", function(self, t, dt, input)
	if self._equipped_unit:base():can_reload() then
		self:_stance_entered()
	end
end)
--]]


Hooks:PreHook(PlayerStandard, "_end_action_steelsight", "turnflip_exitads", function(self, t)
	self:rollback_flipturn_reload_state()
end)

-- need to figure out which flipturn data to use from the top because we've switched between hipfire/ADS
function PlayerStandard:rollback_flipturn_reload_state()
	if self._flipturn_reload_state then
		if self._flipturn_reload_state > 99 then
			self._flipturn_reload_state = 100
		else
			self._flipturn_reload_state = 0
		end
	end
end


Hooks:PostHook(PlayerStandard, "_start_action_running", "turnflip_sarun", function(self, t)
	-- prevent stance from sticking around if interrupting flipturn with a sprint
	self:_stance_entered()
end)

Hooks:PostHook(PlayerStandard, "_interupt_action_reload", "turnflip_interupt_action_reload", function(self, t)
	-- prevent stance from sticking around when you cancel the reload
	rel_cancel = true
	self:_stance_entered()
end)

Hooks:PostHook(PlayerStandard, "update", "turnflip_update", function(self, t, dt)
	if self._state_data.self_shock_expire_t and self._state_data.self_shock_expire_t < t then
		self._ext_movement:on_tase_ended()
	end
	self._last_t = t
	self._last_dt = dt

	-- check shootturn timers
	local fire_timed_stances = self._equipped_unit:base()._fire_timed_stance_mod
	if fire_timed_stances and self._shootturn_state then
		local last_shootturn_state = self._shootturn_state --
		self._last_shot_dt = self._last_t - (self._last_shot_time or 0)
		if self:in_steelsight() then
			fire_timed_stances = fire_timed_stances.ads
		else
			fire_timed_stances = fire_timed_stances.hip
		end
		for i = self._shootturn_state, #fire_timed_stances, 1 do
			if (self._last_shot_dt > fire_timed_stances[i].t) and (self._shootturn_state ~= i) then
				self._shootturn_state = i
			end
		end
		if last_shootturn_state ~= self._shootturn_state then
			self:_stance_entered()
		end
	end

	if not self:is_equipping() and self._equip_stance_check then
		self._equip_stance_check = nil
		self:_stance_entered()
	end
end)

Hooks:PostHook(PlayerStandard, "_start_action_unequip_weapon", "shootturn_reset", function(self, params)
	self._shootturn_state = nil
	self._last_shootturn_sound = 0
end)

Hooks:PostHook(PlayerStandard, "_start_action_equip_weapon", "inf_applyequiphipstancemod", function(self, params)
	self:_stance_entered()
log("applying")
	self._equip_stance_check = true
end)

Hooks:PostHook(PlayerStandard, "_check_action_primary_attack", "turnflip_lastshottime", function(self, t, input)
	if self._shooting and self._equipped_unit:base()._fire_timed_stance_mod then
		self._last_shot_time = t
		self._shootturn_state = 1
		self._last_shootturn_sound = 0
		self:_stance_entered()
	end
end)